/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Link;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Stimulus</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.StimulusImpl#getArgument
 * <em>Argument</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.StimulusImpl#getSender
 * <em>Sender</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.StimulusImpl#getReceiver
 * <em>Receiver</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.StimulusImpl#getCommunicationLink
 * <em>Communication Link</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.StimulusImpl#getDispatchAction
 * <em>Dispatch Action</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class StimulusImpl extends ModelElementImpl implements Stimulus {
	/**
	 * The cached value of the '{@link #getArgument() <em>Argument</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getArgument()
	 * @generated
	 * @ordered
	 */
	protected EList argument = null;

	/**
	 * The cached value of the '{@link #getSender() <em>Sender</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSender()
	 * @generated
	 * @ordered
	 */
	protected Instance sender = null;

	/**
	 * The cached value of the '{@link #getReceiver() <em>Receiver</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getReceiver()
	 * @generated
	 * @ordered
	 */
	protected Instance receiver = null;

	/**
	 * The cached value of the '{@link #getCommunicationLink()
	 * <em>Communication Link</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getCommunicationLink()
	 * @generated
	 * @ordered
	 */
	protected Link communicationLink = null;

	/**
	 * The cached value of the '{@link #getDispatchAction()
	 * <em>Dispatch Action</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getDispatchAction()
	 * @generated
	 * @ordered
	 */
	protected Action dispatchAction = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected StimulusImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getStimulus();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getArgument() {
		if (argument == null) {
			argument = new EObjectWithInverseResolvingEList.ManyInverse(Instance.class, this, Common_behaviorPackage.STIMULUS__ARGUMENT, Common_behaviorPackage.INSTANCE__STIMULUS1);
		}
		return argument;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance getSender() {
		if (sender != null && sender.eIsProxy()) {
			Instance oldSender = sender;
			sender = (Instance) eResolveProxy((InternalEObject) sender);
			if (sender != oldSender) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.STIMULUS__SENDER, oldSender, sender));
			}
		}
		return sender;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance basicGetSender() {
		return sender;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetSender(Instance newSender, NotificationChain msgs) {
		Instance oldSender = sender;
		sender = newSender;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.STIMULUS__SENDER, oldSender, newSender);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSender(Instance newSender) {
		if (newSender != sender) {
			NotificationChain msgs = null;
			if (sender != null)
				msgs = ((InternalEObject) sender).eInverseRemove(this, Common_behaviorPackage.INSTANCE__STIMULUS3, Instance.class, msgs);
			if (newSender != null)
				msgs = ((InternalEObject) newSender).eInverseAdd(this, Common_behaviorPackage.INSTANCE__STIMULUS3, Instance.class, msgs);
			msgs = basicSetSender(newSender, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.STIMULUS__SENDER, newSender, newSender));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance getReceiver() {
		if (receiver != null && receiver.eIsProxy()) {
			Instance oldReceiver = receiver;
			receiver = (Instance) eResolveProxy((InternalEObject) receiver);
			if (receiver != oldReceiver) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.STIMULUS__RECEIVER, oldReceiver, receiver));
			}
		}
		return receiver;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance basicGetReceiver() {
		return receiver;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetReceiver(Instance newReceiver, NotificationChain msgs) {
		Instance oldReceiver = receiver;
		receiver = newReceiver;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.STIMULUS__RECEIVER, oldReceiver, newReceiver);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setReceiver(Instance newReceiver) {
		if (newReceiver != receiver) {
			NotificationChain msgs = null;
			if (receiver != null)
				msgs = ((InternalEObject) receiver).eInverseRemove(this, Common_behaviorPackage.INSTANCE__STIMULUS2, Instance.class, msgs);
			if (newReceiver != null)
				msgs = ((InternalEObject) newReceiver).eInverseAdd(this, Common_behaviorPackage.INSTANCE__STIMULUS2, Instance.class, msgs);
			msgs = basicSetReceiver(newReceiver, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.STIMULUS__RECEIVER, newReceiver, newReceiver));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Link getCommunicationLink() {
		if (communicationLink != null && communicationLink.eIsProxy()) {
			Link oldCommunicationLink = communicationLink;
			communicationLink = (Link) eResolveProxy((InternalEObject) communicationLink);
			if (communicationLink != oldCommunicationLink) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK, oldCommunicationLink, communicationLink));
			}
		}
		return communicationLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Link basicGetCommunicationLink() {
		return communicationLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetCommunicationLink(Link newCommunicationLink, NotificationChain msgs) {
		Link oldCommunicationLink = communicationLink;
		communicationLink = newCommunicationLink;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK, oldCommunicationLink, newCommunicationLink);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setCommunicationLink(Link newCommunicationLink) {
		if (newCommunicationLink != communicationLink) {
			NotificationChain msgs = null;
			if (communicationLink != null)
				msgs = ((InternalEObject) communicationLink).eInverseRemove(this, Common_behaviorPackage.LINK__STIMULUS, Link.class, msgs);
			if (newCommunicationLink != null)
				msgs = ((InternalEObject) newCommunicationLink).eInverseAdd(this, Common_behaviorPackage.LINK__STIMULUS, Link.class, msgs);
			msgs = basicSetCommunicationLink(newCommunicationLink, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK, newCommunicationLink, newCommunicationLink));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Action getDispatchAction() {
		if (dispatchAction != null && dispatchAction.eIsProxy()) {
			Action oldDispatchAction = dispatchAction;
			dispatchAction = (Action) eResolveProxy((InternalEObject) dispatchAction);
			if (dispatchAction != oldDispatchAction) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.STIMULUS__DISPATCH_ACTION, oldDispatchAction, dispatchAction));
			}
		}
		return dispatchAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Action basicGetDispatchAction() {
		return dispatchAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetDispatchAction(Action newDispatchAction, NotificationChain msgs) {
		Action oldDispatchAction = dispatchAction;
		dispatchAction = newDispatchAction;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.STIMULUS__DISPATCH_ACTION, oldDispatchAction, newDispatchAction);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDispatchAction(Action newDispatchAction) {
		if (newDispatchAction != dispatchAction) {
			NotificationChain msgs = null;
			if (dispatchAction != null)
				msgs = ((InternalEObject) dispatchAction).eInverseRemove(this, Common_behaviorPackage.ACTION__STIMULUS, Action.class, msgs);
			if (newDispatchAction != null)
				msgs = ((InternalEObject) newDispatchAction).eInverseAdd(this, Common_behaviorPackage.ACTION__STIMULUS, Action.class, msgs);
			msgs = basicSetDispatchAction(newDispatchAction, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.STIMULUS__DISPATCH_ACTION, newDispatchAction, newDispatchAction));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.STIMULUS__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.STIMULUS__NAMESPACE, msgs);
			case Common_behaviorPackage.STIMULUS__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__ARGUMENT:
				return ((InternalEList) getArgument()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__SENDER:
				if (sender != null)
					msgs = ((InternalEObject) sender).eInverseRemove(this, Common_behaviorPackage.INSTANCE__STIMULUS3, Instance.class, msgs);
				return basicSetSender((Instance) otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__RECEIVER:
				if (receiver != null)
					msgs = ((InternalEObject) receiver).eInverseRemove(this, Common_behaviorPackage.INSTANCE__STIMULUS2, Instance.class, msgs);
				return basicSetReceiver((Instance) otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK:
				if (communicationLink != null)
					msgs = ((InternalEObject) communicationLink).eInverseRemove(this, Common_behaviorPackage.LINK__STIMULUS, Link.class, msgs);
				return basicSetCommunicationLink((Link) otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__DISPATCH_ACTION:
				if (dispatchAction != null)
					msgs = ((InternalEObject) dispatchAction).eInverseRemove(this, Common_behaviorPackage.ACTION__STIMULUS, Action.class, msgs);
				return basicSetDispatchAction((Action) otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.STIMULUS__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.STIMULUS__NAMESPACE, msgs);
			case Common_behaviorPackage.STIMULUS__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__BINDING:
				return basicSetBinding(null, msgs);
			case Common_behaviorPackage.STIMULUS__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case Common_behaviorPackage.STIMULUS__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__ARGUMENT:
				return ((InternalEList) getArgument()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.STIMULUS__SENDER:
				return basicSetSender(null, msgs);
			case Common_behaviorPackage.STIMULUS__RECEIVER:
				return basicSetReceiver(null, msgs);
			case Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK:
				return basicSetCommunicationLink(null, msgs);
			case Common_behaviorPackage.STIMULUS__DISPATCH_ACTION:
				return basicSetDispatchAction(null, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.STIMULUS__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.STIMULUS__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.STIMULUS__NAME:
			return getName();
		case Common_behaviorPackage.STIMULUS__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.STIMULUS__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.STIMULUS__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.STIMULUS__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.STIMULUS__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.STIMULUS__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.STIMULUS__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.STIMULUS__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.STIMULUS__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case Common_behaviorPackage.STIMULUS__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case Common_behaviorPackage.STIMULUS__COMMENT:
			return getComment();
		case Common_behaviorPackage.STIMULUS__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case Common_behaviorPackage.STIMULUS__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case Common_behaviorPackage.STIMULUS__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.STIMULUS__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.STIMULUS__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.STIMULUS__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.STIMULUS__PARTITION:
			return getPartition();
		case Common_behaviorPackage.STIMULUS__ARGUMENT:
			return getArgument();
		case Common_behaviorPackage.STIMULUS__SENDER:
			if (resolve)
				return getSender();
			return basicGetSender();
		case Common_behaviorPackage.STIMULUS__RECEIVER:
			if (resolve)
				return getReceiver();
			return basicGetReceiver();
		case Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK:
			if (resolve)
				return getCommunicationLink();
			return basicGetCommunicationLink();
		case Common_behaviorPackage.STIMULUS__DISPATCH_ACTION:
			if (resolve)
				return getDispatchAction();
			return basicGetDispatchAction();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.STIMULUS__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.STIMULUS__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__BINDING:
			setBinding((Binding) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__ARGUMENT:
			getArgument().clear();
			getArgument().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__SENDER:
			setSender((Instance) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__RECEIVER:
			setReceiver((Instance) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK:
			setCommunicationLink((Link) newValue);
			return;
		case Common_behaviorPackage.STIMULUS__DISPATCH_ACTION:
			setDispatchAction((Action) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.STIMULUS__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.STIMULUS__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.STIMULUS__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.STIMULUS__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.STIMULUS__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.STIMULUS__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.STIMULUS__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.STIMULUS__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.STIMULUS__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.STIMULUS__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.STIMULUS__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case Common_behaviorPackage.STIMULUS__BINDING:
			setBinding((Binding) null);
			return;
		case Common_behaviorPackage.STIMULUS__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.STIMULUS__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case Common_behaviorPackage.STIMULUS__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case Common_behaviorPackage.STIMULUS__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.STIMULUS__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.STIMULUS__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.STIMULUS__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.STIMULUS__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.STIMULUS__ARGUMENT:
			getArgument().clear();
			return;
		case Common_behaviorPackage.STIMULUS__SENDER:
			setSender((Instance) null);
			return;
		case Common_behaviorPackage.STIMULUS__RECEIVER:
			setReceiver((Instance) null);
			return;
		case Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK:
			setCommunicationLink((Link) null);
			return;
		case Common_behaviorPackage.STIMULUS__DISPATCH_ACTION:
			setDispatchAction((Action) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.STIMULUS__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.STIMULUS__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.STIMULUS__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case Common_behaviorPackage.STIMULUS__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.STIMULUS__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.STIMULUS__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.STIMULUS__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.STIMULUS__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.STIMULUS__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.STIMULUS__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.STIMULUS__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case Common_behaviorPackage.STIMULUS__BINDING:
			return binding != null;
		case Common_behaviorPackage.STIMULUS__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.STIMULUS__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.STIMULUS__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case Common_behaviorPackage.STIMULUS__STEREOTYPE:
			return stereotype != null;
		case Common_behaviorPackage.STIMULUS__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.STIMULUS__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.STIMULUS__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.STIMULUS__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.STIMULUS__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.STIMULUS__ARGUMENT:
			return argument != null && !argument.isEmpty();
		case Common_behaviorPackage.STIMULUS__SENDER:
			return sender != null;
		case Common_behaviorPackage.STIMULUS__RECEIVER:
			return receiver != null;
		case Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK:
			return communicationLink != null;
		case Common_behaviorPackage.STIMULUS__DISPATCH_ACTION:
			return dispatchAction != null;
		}
		return eDynamicIsSet(eFeature);
	}

} // StimulusImpl
